git-filter-branch.sh 15.4 KB
Newer Older
1 2 3 4 5 6
#!/bin/sh
#
# Rewrite revision history
# Copyright (c) Petr Baudis, 2006
# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
#
7 8 9
# Lets you rewrite the revision history of the current branch, creating
# a new branch. You can specify a number of filters to modify the commits,
# files and trees.
10

11 12 13
# The following functions will also be available in the commit filter:

functions=$(cat << \EOF
14 15
EMPTY_TREE=$(git hash-object -t tree /dev/null)

16
warn () {
17
	echo "$*" >&2
18 19
}

20 21
map()
{
22
	# if it was not rewritten, take the original
23 24 25 26 27 28
	if test -r "$workdir/../map/$1"
	then
		cat "$workdir/../map/$1"
	else
		echo "$1"
	fi
29 30
}

31 32 33 34 35 36 37 38 39 40 41 42 43 44
# if you run 'skip_commit "$@"' in a commit filter, it will print
# the (mapped) parents, effectively skipping the commit.

skip_commit()
{
	shift;
	while [ -n "$1" ];
	do
		shift;
		map "$1";
		shift;
	done;
}

45 46 47 48 49 50
# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
# it will skip commits that leave the tree untouched, commit the other.
git_commit_non_empty_tree()
{
	if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
		map "$3"
51
	elif test $# = 1 && test "$1" = $EMPTY_TREE; then
52
		:
53 54 55 56
	else
		git commit-tree "$@"
	fi
}
57 58 59 60 61 62 63 64 65
# override die(): this version puts in an extra line break, so that
# the progress is still visible

die()
{
	echo >&2
	echo "$*" >&2
	exit 1
}
66 67 68 69
EOF
)

eval "$functions"
70

71 72 73 74 75 76 77 78
finish_ident() {
	# Ensure non-empty id name.
	echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
	# And make sure everything is exported.
	echo "export GIT_$1_NAME"
	echo "export GIT_$1_EMAIL"
	echo "export GIT_$1_DATE"
}
79 80

set_ident () {
81 82 83
	parse_ident_from_commit author AUTHOR committer COMMITTER
	finish_ident AUTHOR
	finish_ident COMMITTER
84 85
}

86
USAGE="[--setup <command>] [--subdirectory-filter <directory>] [--env-filter <command>]
87 88 89
	[--tree-filter <command>] [--index-filter <command>]
	[--parent-filter <command>] [--msg-filter <command>]
	[--commit-filter <command>] [--tag-name-filter <command>]
90
	[--original <namespace>]
91
	[-d <directory>] [-f | --force] [--state-branch <branch>]
92
	[--] [<rev-list options>...]"
93

94
OPTIONS_SPEC=
95 96
. git-sh-setup

97
if [ "$(is_bare_repository)" = false ]; then
98
	require_clean_work_tree 'rewrite branches'
99
fi
100

101
tempdir=.git-rewrite
102
filter_setup=
103 104 105 106 107
filter_env=
filter_tree=
filter_index=
filter_parent=
filter_msg=cat
108
filter_commit=
109
filter_tag_name=
110
filter_subdir=
111
state_branch=
112 113
orig_namespace=refs/original/
force=
114
prune_empty=
115
remap_to_ancestor=
116
while :
117 118 119 120 121 122
do
	case "$1" in
	--)
		shift
		break
		;;
123 124 125 126 127
	--force|-f)
		shift
		force=t
		continue
		;;
128
	--remap-to-ancestor)
129
		# deprecated ($remap_to_ancestor is set now automatically)
130 131 132 133
		shift
		remap_to_ancestor=t
		continue
		;;
134 135 136 137 138
	--prune-empty)
		shift
		prune_empty=t
		continue
		;;
139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155
	-*)
		;;
	*)
		break;
	esac

	# all switches take one argument
	ARG="$1"
	case "$#" in 1) usage ;; esac
	shift
	OPTARG="$1"
	shift

	case "$ARG" in
	-d)
		tempdir="$OPTARG"
		;;
156 157 158
	--setup)
		filter_setup="$OPTARG"
		;;
159 160 161 162
	--subdirectory-filter)
		filter_subdir="$OPTARG"
		remap_to_ancestor=t
		;;
163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178
	--env-filter)
		filter_env="$OPTARG"
		;;
	--tree-filter)
		filter_tree="$OPTARG"
		;;
	--index-filter)
		filter_index="$OPTARG"
		;;
	--parent-filter)
		filter_parent="$OPTARG"
		;;
	--msg-filter)
		filter_msg="$OPTARG"
		;;
	--commit-filter)
179
		filter_commit="$functions; $OPTARG"
180 181 182 183
		;;
	--tag-name-filter)
		filter_tag_name="$OPTARG"
		;;
184
	--original)
185
		orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
186
		;;
187 188 189
	--state-branch)
		state_branch="$OPTARG"
		;;
190 191 192 193 194 195
	*)
		usage
		;;
	esac
done

196 197 198 199 200 201 202 203
case "$prune_empty,$filter_commit" in
,)
	filter_commit='git commit-tree "$@"';;
t,)
	filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
,*)
	;;
*)
204
	die "Cannot set --prune-empty and --commit-filter at the same time"
205 206
esac

207 208 209 210 211 212 213 214
case "$force" in
t)
	rm -rf "$tempdir"
;;
'')
	test -d "$tempdir" &&
		die "$tempdir already exists, please remove it"
esac
215
orig_dir=$(pwd)
216
mkdir -p "$tempdir/t" &&
217
tempdir="$(cd "$tempdir"; pwd)" &&
218 219 220
cd "$tempdir/t" &&
workdir="$(pwd)" ||
die ""
221

222
# Remove tempdir on exit
223
trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
224

225 226 227
ORIG_GIT_DIR="$GIT_DIR"
ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
228 229 230 231 232 233 234
ORIG_GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME"
ORIG_GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL"
ORIG_GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE"
ORIG_GIT_COMMITTER_NAME="$GIT_COMMITTER_NAME"
ORIG_GIT_COMMITTER_EMAIL="$GIT_COMMITTER_EMAIL"
ORIG_GIT_COMMITTER_DATE="$GIT_COMMITTER_DATE"

235 236 237
GIT_WORK_TREE=.
export GIT_DIR GIT_WORK_TREE

238
# Make sure refs/original is empty
239
git for-each-ref > "$tempdir"/backup-refs || exit
240 241 242 243
while read sha1 type name
do
	case "$force,$name" in
	,$orig_namespace*)
244 245 246
		die "Cannot create a new backup.
A previous backup already exists in $orig_namespace
Force overwriting the backup with -f"
247 248 249 250 251 252 253
	;;
	t,$orig_namespace*)
		git update-ref -d "$name" $sha1
	;;
	esac
done < "$tempdir"/backup-refs

254
# The refs should be updated if their heads were rewritten
255
git rev-parse --no-flags --revs-only --symbolic-full-name \
256 257 258 259 260 261 262 263 264 265 266 267
	--default HEAD "$@" > "$tempdir"/raw-refs || exit
while read ref
do
	case "$ref" in ^?*) continue ;; esac

	if git rev-parse --verify "$ref"^0 >/dev/null 2>&1
	then
		echo "$ref"
	else
		warn "WARNING: not rewriting '$ref' (not a committish)"
	fi
done >"$tempdir"/heads <"$tempdir"/raw-refs
268 269

test -s "$tempdir"/heads ||
270
	die "You must specify a ref to rewrite."
271

272 273
GIT_INDEX_FILE="$(pwd)/../index"
export GIT_INDEX_FILE
274

275 276
# map old->new commit ids for rewriting parents
mkdir ../map || die "Could not create map/ directory"
277

278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297
if test -n "$state_branch"
then
	state_commit=$(git rev-parse --no-flags --revs-only "$state_branch")
	if test -n "$state_commit"
	then
		echo "Populating map from $state_branch ($state_commit)" 1>&2
		perl -e'open(MAP, "-|", "git show $ARGV[0]:filter.map") or die;
			while (<MAP>) {
				m/(.*):(.*)/ or die;
				open F, ">../map/$1" or die;
				print F "$2" or die;
				close(F) or die;
			}
			close(MAP) or die;' "$state_commit" \
				|| die "Unable to load state from $state_branch:filter.map"
	else
		echo "Branch $state_branch does not exist. Will create" 1>&2
	fi
fi

298 299
# we need "--" only if there are no path arguments in $@
nonrevs=$(git rev-parse --no-revs "$@") || exit
300 301 302 303 304 305 306 307
if test -z "$nonrevs"
then
	dashdash=--
else
	dashdash=
	remap_to_ancestor=t
fi

308
git rev-parse --revs-only "$@" >../parse
309

310 311
case "$filter_subdir" in
"")
312
	eval set -- "$(git rev-parse --sq --no-revs "$@")"
313 314
	;;
*)
315 316 317 318 319 320
	eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
		"$filter_subdir")"
	;;
esac

git rev-list --reverse --topo-order --default HEAD \
321
	--parents --simplify-merges --stdin "$@" <../parse >../revs ||
322
	die "Could not get the commits"
323
commits=$(wc -l <../revs | tr -d " ")
324

325
test $commits -eq 0 && die_with_status 2 "Found nothing to rewrite"
326

327
# Rewrite the commits
328 329 330 331 332
report_progress ()
{
	if test -n "$progress" &&
		test $git_filter_branch__commit_count -gt $next_sample_at
	then
333 334 335 336 337 338
		count=$git_filter_branch__commit_count

		now=$(date +%s)
		elapsed=$(($now - $start_timestamp))
		remaining=$(( ($commits - $count) * $elapsed / $count ))
		if test $elapsed -gt 0
339
		then
340
			next_sample_at=$(( ($elapsed + 1) * $count / $elapsed ))
341 342 343
		else
			next_sample_at=$(($next_sample_at + 1))
		fi
344
		progress=" ($elapsed seconds passed, remaining $remaining predicted)"
345
	fi
346
	printf "\rRewrite $commit ($count/$commits)$progress    "
347
}
348

349
git_filter_branch__commit_count=0
350 351 352 353 354 355 356 357 358

progress= start_timestamp=
if date '+%s' 2>/dev/null | grep -q '^[0-9][0-9]*$'
then
	next_sample_at=0
	progress="dummy to ensure this is not empty"
	start_timestamp=$(date '+%s')
fi

359 360 361 362 363 364 365 366 367
if test -n "$filter_index" ||
   test -n "$filter_tree" ||
   test -n "$filter_subdir"
then
	need_index=t
else
	need_index=
fi

368 369 370
eval "$filter_setup" < /dev/null ||
	die "filter setup failed: $filter_setup"

371
while read commit parents; do
372
	git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
373 374

	report_progress
375
	test -f "$workdir"/../map/$commit && continue
376

377 378
	case "$filter_subdir" in
	"")
379 380 381 382
		if test -n "$need_index"
		then
			GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
		fi
383 384
		;;
	*)
385
		# The commit may not have the subdirectory at all
386 387
		err=$(GIT_ALLOW_NULL_SHA1=1 \
		      git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
388
			if ! git rev-parse -q --verify $commit:"$filter_subdir"
389 390 391 392 393 394 395
			then
				rm -f "$GIT_INDEX_FILE"
			else
				echo >&2 "$err"
				false
			fi
		}
396
	esac || die "Could not initialize the index"
397

398 399
	GIT_COMMIT=$commit
	export GIT_COMMIT
400 401
	git cat-file commit "$commit" >../commit ||
		die "Cannot read commit $commit"
402

403 404
	eval "$(set_ident <../commit)" ||
		die "setting author/committer failed for commit $commit"
405 406
	eval "$filter_env" < /dev/null ||
		die "env filter failed: $filter_env"
407 408

	if [ "$filter_tree" ]; then
409 410
		git checkout-index -f -u -a ||
			die "Could not checkout the index"
411 412
		# files that $commit removed are now still in the working tree;
		# remove them, else they would be added again
413
		git clean -d -q -f -x
414 415 416
		eval "$filter_tree" < /dev/null ||
			die "tree filter failed: $filter_tree"

417
		(
418
			git diff-index -r --name-only --ignore-submodules $commit -- &&
419
			git ls-files --others
420 421 422
		) > "$tempdir"/tree-state || exit
		git update-index --add --replace --remove --stdin \
			< "$tempdir"/tree-state || exit
423 424
	fi

425 426
	eval "$filter_index" < /dev/null ||
		die "index filter failed: $filter_index"
427 428

	parentstr=
429
	for parent in $parents; do
430
		for reparent in $(map "$parent"); do
431 432 433 434 435 436 437
			case "$parentstr " in
			*" -p $reparent "*)
				;;
			*)
				parentstr="$parentstr -p $reparent"
				;;
			esac
438
		done
439 440
	done
	if [ "$filter_parent" ]; then
441 442
		parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
				die "parent filter failed: $filter_parent"
443 444
	fi

445
	{
446
		while IFS='' read -r header_line && test -n "$header_line"
447 448 449 450 451 452 453
		do
			# skip header lines...
			:;
		done
		# and output the actual commit message
		cat
	} <../commit |
454 455
		eval "$filter_msg" > ../message ||
			die "msg filter failed: $filter_msg"
456 457 458 459 460

	if test -n "$need_index"
	then
		tree=$(git write-tree)
	else
461
		tree=$(git rev-parse "$commit^{tree}")
462
	fi
463
	workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
464
		"$tree" $parentstr < ../message > ../map/$commit ||
465
			die "could not write rewritten commit"
466 467
done <../revs

468 469 470 471 472
# If we are filtering for paths, as in the case of a subdirectory
# filter, it is possible that a specified head is not in the set of
# rewritten commits, because it was pruned by the revision walker.
# Ancestor remapping fixes this by mapping these heads to the unique
# nearest ancestor that survived the pruning.
473

474
if test "$remap_to_ancestor" = t
475 476
then
	while read ref
477
	do
478 479
		sha1=$(git rev-parse "$ref"^0)
		test -f "$workdir"/../map/$sha1 && continue
480
		ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
481 482 483
		test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
	done < "$tempdir"/heads
fi
484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506

# Finally update the refs

_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
echo
while read ref
do
	# avoid rewriting a ref twice
	test -f "$orig_namespace$ref" && continue

	sha1=$(git rev-parse "$ref"^0)
	rewritten=$(map $sha1)

	test $sha1 = "$rewritten" &&
		warn "WARNING: Ref '$ref' is unchanged" &&
		continue

	case "$rewritten" in
	'')
		echo "Ref '$ref' was deleted"
		git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
			die "Could not delete $ref"
507
	;;
508 509
	$_x40)
		echo "Ref '$ref' was rewritten"
510 511 512 513 514 515 516 517 518 519 520
		if ! git update-ref -m "filter-branch: rewrite" \
					"$ref" $rewritten $sha1 2>/dev/null; then
			if test $(git cat-file -t "$ref") = tag; then
				if test -z "$filter_tag_name"; then
					warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
					warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
				fi
			else
				die "Could not rewrite $ref"
			fi
		fi
521
	;;
522 523 524 525 526 527 528 529 530 531 532
	*)
		# NEEDSWORK: possibly add -Werror, making this an error
		warn "WARNING: '$ref' was rewritten into multiple commits:"
		warn "$rewritten"
		warn "WARNING: Ref '$ref' points to the first one now."
		rewritten=$(echo "$rewritten" | head -n 1)
		git update-ref -m "filter-branch: rewrite to first" \
				"$ref" $rewritten $sha1 ||
			die "Could not rewrite $ref"
	;;
	esac
533 534
	git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
		 exit
535 536 537 538 539
done < "$tempdir"/heads

# TODO: This should possibly go, with the semantics that all positive given
#       refs are updated, and their original heads stored in refs/original/
# Filter tags
540 541

if [ "$filter_tag_name" ]; then
542
	git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
543 544 545 546 547 548 549 550 551 552
	while read sha1 type ref; do
		ref="${ref#refs/tags/}"
		# XXX: Rewrite tagged trees as well?
		if [ "$type" != "commit" -a "$type" != "tag" ]; then
			continue;
		fi

		if [ "$type" = "tag" ]; then
			# Dereference to a commit
			sha1t="$sha1"
553
			sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
554 555 556 557
		fi

		[ -f "../map/$sha1" ] || continue
		new_sha1="$(cat "../map/$sha1")"
558 559
		GIT_COMMIT="$sha1"
		export GIT_COMMIT
560 561
		new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
			die "tag name filter failed: $filter_tag_name"
562 563 564 565

		echo "$ref -> $new_ref ($sha1 -> $new_sha1)"

		if [ "$type" = "tag" ]; then
566 567 568
			new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
						"$new_sha1" "$new_ref"
				git cat-file tag "$ref" |
569
				sed -n \
570
				    -e '1,/^$/{
571 572 573
					  /^object /d
					  /^type /d
					  /^tag /d
574
					}' \
575
				    -e '/^-----BEGIN PGP SIGNATURE-----/q' \
576
				    -e 'p' ) |
577
				git hash-object -t tag -w --stdin) ||
578 579
				die "Could not create new tag object for $ref"
			if git cat-file tag "$ref" | \
580
			   sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
581 582 583
			then
				warn "gpg signature stripped from tag object $sha1t"
			fi
584 585
		fi

586 587
		git update-ref "refs/tags/$new_ref" "$new_sha1" ||
			die "Could not write tag $new_ref"
588 589 590
	done
fi

591
unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
592 593
unset GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
unset GIT_COMMITTER_NAME GIT_COMMITTER_EMAIL GIT_COMMITTER_DATE
594 595 596 597 598 599 600 601 602 603 604
test -z "$ORIG_GIT_DIR" || {
	GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
}
test -z "$ORIG_GIT_WORK_TREE" || {
	GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
	export GIT_WORK_TREE
}
test -z "$ORIG_GIT_INDEX_FILE" || {
	GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
	export GIT_INDEX_FILE
}
605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628
test -z "$ORIG_GIT_AUTHOR_NAME" || {
	GIT_AUTHOR_NAME="$ORIG_GIT_AUTHOR_NAME" &&
	export GIT_AUTHOR_NAME
}
test -z "$ORIG_GIT_AUTHOR_EMAIL" || {
	GIT_AUTHOR_EMAIL="$ORIG_GIT_AUTHOR_EMAIL" &&
	export GIT_AUTHOR_EMAIL
}
test -z "$ORIG_GIT_AUTHOR_DATE" || {
	GIT_AUTHOR_DATE="$ORIG_GIT_AUTHOR_DATE" &&
	export GIT_AUTHOR_DATE
}
test -z "$ORIG_GIT_COMMITTER_NAME" || {
	GIT_COMMITTER_NAME="$ORIG_GIT_COMMITTER_NAME" &&
	export GIT_COMMITTER_NAME
}
test -z "$ORIG_GIT_COMMITTER_EMAIL" || {
	GIT_COMMITTER_EMAIL="$ORIG_GIT_COMMITTER_EMAIL" &&
	export GIT_COMMITTER_EMAIL
}
test -z "$ORIG_GIT_COMMITTER_DATE" || {
	GIT_COMMITTER_DATE="$ORIG_GIT_COMMITTER_DATE" &&
	export GIT_COMMITTER_DATE
}
629

630 631 632 633 634 635 636 637 638 639 640 641 642
if test -n "$state_branch"
then
	echo "Saving rewrite state to $state_branch" 1>&2
	state_blob=$(
		perl -e'opendir D, "../map" or die;
			open H, "|-", "git hash-object -w --stdin" or die;
			foreach (sort readdir(D)) {
				next if m/^\.\.?$/;
				open F, "<../map/$_" or die;
				chomp($f = <F>);
				print H "$_:$f\n" or die;
			}
			close(H) or die;' || die "Unable to save state")
643
	state_tree=$(printf '100644 blob %s\tfilter.map\n' "$state_blob" | git mktree)
644 645
	if test -n "$state_commit"
	then
646
		state_commit=$(echo "Sync" | git commit-tree "$state_tree" -p "$state_commit")
647
	else
648
		state_commit=$(echo "Sync" | git commit-tree "$state_tree" )
649 650 651 652
	fi
	git update-ref "$state_branch" "$state_commit"
fi

653 654 655 656 657
cd "$orig_dir"
rm -rf "$tempdir"

trap - 0

658
if [ "$(is_bare_repository)" = false ]; then
659
	git read-tree -u -m HEAD || exit
660
fi
661

662
exit 0